diff --git a/game/client/src/main/java/net/minecraft/client/option/KeyBinding.java b/game/client/src/main/java/net/minecraft/client/option/KeyBinding.java
index 62ed5f654..dc381a2c7 100644
--- a/game/client/src/main/java/net/minecraft/client/option/KeyBinding.java
+++ b/game/client/src/main/java/net/minecraft/client/option/KeyBinding.java
@@ -9,8 +9,8 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class KeyBinding {
-	private static Map<Character, InputDevice> charToInputDeviceMap = new HashMap<>();
-	private static Map<InputDevice, Character> inputDeviceToCharMap = new HashMap<>();
+	private static final Map<Character, InputDevice> charToInputDeviceMap = new HashMap<>();
+	private static final Map<InputDevice, Character> inputDeviceToCharMap = new HashMap<>();
 	
 	public static void addInputDevice(char c, InputDevice inputDevice) {
 		if(charToInputDeviceMap.containsKey(c)) {
@@ -28,7 +28,7 @@ public class KeyBinding {
 		addInputDevice('k', InputDevice.keyboard);
 	}
 	
-	private final String id;
+	private final @NotNull String id;
 	
 	private @Nullable InputDevice inputDevice;
 	private int keyCode = -1;
@@ -36,11 +36,10 @@ public class KeyBinding {
 	private @Nullable InputDevice defaultInputDevice = null;
 	private int defaultKeyCode = -1;
 
-	public KeyBinding(String id) {
+	public KeyBinding(@NotNull String id) {
 		this.id = id;
 		this.inputDevice = null;
 		this.keyCode = -1;
-		GameSettings.keys.add(this);
 	}
 
 	public @NotNull KeyBinding setDefault(final @Nullable InputDevice device, final int keyCode) {
@@ -71,8 +70,8 @@ public class KeyBinding {
 	}
 
 	public @NotNull KeyBinding resetToDefault() {
-		this.keyCode = defaultKeyCode;
-		this.inputDevice = defaultInputDevice;
+		this.keyCode = this.defaultKeyCode;
+		this.inputDevice = this.defaultInputDevice;
 		return this;
 	}
 
@@ -81,60 +80,60 @@ public class KeyBinding {
 	}
 
 	public String getId() {
-		return id;
+		return this.id;
 	}
 
 	public InputDevice getInputDevice() {
-		return inputDevice;
+		return this.inputDevice;
 	}
 	
 	public int getKeyCode() {
-		return keyCode;
+		return this.keyCode;
 	}
 
 	public InputDevice getDefaultInputDevice() {
-		return defaultInputDevice;
+		return this.defaultInputDevice;
 	}
 
 	public int getDefaultKeyCode() {
-		return defaultKeyCode;
+		return this.defaultKeyCode;
 	}
 
 	public boolean isPressed() {
-		if(inputDevice != null) {
-			return inputDevice.isPressed(keyCode);
+		if(this.inputDevice != null) {
+			return this.inputDevice.isPressed(this.keyCode);
 		}
 		return false;
 	}
 
 	public boolean isPressEvent(InputDevice eventInputDevice) {
-		if(inputDevice == eventInputDevice) {
-			return inputDevice.isPressEvent(keyCode);
+		if(this.inputDevice == eventInputDevice) {
+			return this.inputDevice.isPressEvent(this.keyCode);
 		}
 		return false;
 	}
 	public boolean isPressEvent() {
-		if(inputDevice != null) {
-			return inputDevice.isPressEvent(keyCode);
+		if(this.inputDevice != null) {
+			return this.inputDevice.isPressEvent(this.keyCode);
 		}
 		return false;
 	}
 
 	public boolean isReleaseEvent(InputDevice eventInputDevice) {
-		if(inputDevice == eventInputDevice) {
-			return inputDevice.isReleaseEvent(keyCode);
+		if(this.inputDevice == eventInputDevice) {
+			return this.inputDevice.isReleaseEvent(this.keyCode);
 		}
 		return false;
 	}
 	public boolean isReleaseEvent() {
-		if(inputDevice != null) {
-			return inputDevice.isReleaseEvent(keyCode);
+		if(this.inputDevice != null) {
+			return this.inputDevice.isReleaseEvent(this.keyCode);
 		}
 		return false;
 	}
 
 	public void fromOptionsString(String value) {
-		if(value.length() == 0) {
+		if(value.isEmpty()) {
 			unbind();
 			return;
 		}
@@ -160,23 +159,23 @@ public class KeyBinding {
 	}
 
 	public String toOptionsString() {
-		Character c = inputDeviceToCharMap.get(inputDevice);
+		Character c = inputDeviceToCharMap.get(this.inputDevice);
 		if(c != null) {
-			return String.valueOf(c) + keyCode;
+			return String.valueOf(c) + this.keyCode;
 		}
 		return "";
 	}
 	
 	public boolean isKeyboardKey(int key) {
-		if(inputDevice == InputDevice.keyboard) {
-			return keyCode == key;
+		if(this.inputDevice == InputDevice.keyboard) {
+			return this.keyCode == key;
 		}
 		return false;
 	}
 
 	public boolean isMouseButton(int button) {
-		if(inputDevice == InputDevice.mouse) {
-			return keyCode == button;
+		if(this.inputDevice == InputDevice.mouse) {
+			return this.keyCode == button;
 		}
 		return false;
 	}
@@ -186,17 +185,17 @@ public class KeyBinding {
 	}
 	
 	public boolean isBound() {
-		return inputDevice != null;
+		return this.inputDevice != null;
 	}
 	
 	public String getKeyName() {
-		if(inputDevice == null) {
+		if(this.inputDevice == null) {
 			return I18n.getInstance().translateKey("key.disabled");
 		}
 		
-		String keyName = inputDevice.getKeyName(keyCode);
+		String keyName = this.inputDevice.getKeyName(this.keyCode);
 		if(keyName == null) {
-			keyName = String.valueOf(keyCode);
+			keyName = String.valueOf(this.keyCode);
 		} else if ("LCONTROL".equals(keyName)) {
 			keyName = "LCTRL";
 		} else if ("RCONTROL".equals(keyName)) {
diff --git a/game/client/src/main/java/net/minecraft/client/option/Option.java b/game/client/src/main/java/net/minecraft/client/option/Option.java
index c76c55881..bcedbf30a 100644
--- a/game/client/src/main/java/net/minecraft/client/option/Option.java
+++ b/game/client/src/main/java/net/minecraft/client/option/Option.java
@@ -1,8 +1,9 @@
 package net.minecraft.client.option;
 
-import net.minecraft.client.gui.paged.CallbackComponent;
+import net.minecraft.client.Minecraft;
 import net.minecraft.core.lang.I18n;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -10,54 +11,59 @@ import java.util.List;
 import static net.minecraft.core.util.Util.emptyStringIfNull;
 
 public abstract class Option<E> {
-
-	public final @NotNull GameSettings gameSettings;
-	public final @NotNull String name;
+	public final @NotNull String id;
 	public @NotNull E value;
 	protected final @NotNull E defaultValue;
-	protected final List<OptionCallback<E>> callbacks = new ArrayList<>();
+	protected @Nullable DisplayStringProvider<E> displayStringProvider;
+	protected final List<OptionCallback<E>> onChangeCallbacks = new ArrayList<>();
 
-	public Option(final @NotNull GameSettings gameSettings, final @NotNull String name, final @NotNull E defaultValue) {
-		this.gameSettings = gameSettings;
-		this.name = name;
+	public Option(final @NotNull String id, final @NotNull E defaultValue) {
+		this.id = id;
 		this.value = defaultValue;
 		this.defaultValue = defaultValue;
-		GameSettings.options.add(this);
 	}
 
 	public void set(final @NotNull E value) {
 		this.value = value;
 	}
 
-	public void addCallback(final @NotNull OptionCallback<E> callback) {
-		this.callbacks.add(callback);
+	public <T extends Option<E>> @NotNull T addOnChangeCallback(final @NotNull OptionCallback<E> callback) {
+		this.onChangeCallbacks.add(callback);
+		return (T) this;
+	}
+
+	public <T extends Option<E>> @NotNull T withDisplayStringProvider(final @NotNull DisplayStringProvider<E> provider) {
+		this.displayStringProvider = provider;
+		return (T) this;
 	}
 
-	public abstract void parse(final @NotNull String string);
+	public abstract void fromOptionsString(final @NotNull String string);
 
 	public void onUpdate() {
-		for (final @NotNull OptionCallback<E> callback : this.callbacks) {
-			callback.onUpdate(this);
+		for (final @NotNull OptionCallback<E> callback : this.onChangeCallbacks) {
+			callback.onUpdate(Minecraft.getMinecraft(), this);
 		}
-        this.gameSettings.optionChanged(this);
     }
 
 	public @NotNull String getDisplayString() {
-        return this.gameSettings.getDisplayString(this);
+		if (this.displayStringProvider != null) {
+			return this.displayStringProvider.getDisplayString(Minecraft.getMinecraft(), I18n.getInstance(), this);
+		}
+		return toOptionsString();
     }
 
 	public @NotNull String getDisplayStringValue() {
-        return this.gameSettings.getDisplayString(this);
+        return getDisplayString();
     }
 
 	public @NotNull String getDisplayStringName() {
-		return I18n.getInstance().translateKey("options." + this.name);
+		return I18n.getInstance().translateKey("options." + this.id);
 	}
 
 	/**
 	 * The String that is saved to the options.txt file. Don't include spaces!
 	 */
-	public @NotNull String getValueString() {
+	public @NotNull String toOptionsString() {
 		return emptyStringIfNull(this.value.toString());
 	}
 
@@ -66,6 +72,10 @@ public abstract class Option<E> {
 	}
 
 	public interface OptionCallback<T> {
-		void onUpdate(Option<T> option);
+		void onUpdate(@NotNull Minecraft mc, @NotNull Option<T> option);
+	}
+
+	public interface DisplayStringProvider<T> {
+		@NotNull String getDisplayString(@NotNull Minecraft mc, @NotNull I18n i18n, @NotNull Option<T> option);
 	}
 }
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionBoolean.java b/game/client/src/main/java/net/minecraft/client/option/OptionBoolean.java
index 876d9dce4..851162df1 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionBoolean.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionBoolean.java
@@ -1,14 +1,16 @@
 package net.minecraft.client.option;
 
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.Toggleable;
 import org.jetbrains.annotations.NotNull;
 
-public class OptionBoolean extends OptionToggleable<Boolean> implements Toggleable{
+public class OptionBoolean extends OptionToggleable<@NotNull Boolean> implements Toggleable{
 	
 	public static final Boolean[] values = new Boolean[] {false, true};
 	
-	public OptionBoolean(GameSettings gameSettings, String name, boolean value) {
-		super(gameSettings, name, value, values);
+	public OptionBoolean(@NotNull String name, boolean value) {
+		super(name, value, values);
 	}
 	
 	public boolean isBoolean() {
@@ -16,7 +18,7 @@ public class OptionBoolean extends OptionToggleable<Boolean> implements Toggleab
 	}
 
 	@Override
-	public void parse(@NotNull String string) {
+	public void fromOptionsString(@NotNull String string) {
 		this.value = string.equalsIgnoreCase("true");
 	}
 
@@ -26,7 +28,19 @@ public class OptionBoolean extends OptionToggleable<Boolean> implements Toggleab
 	}
 
 	public boolean isTrue() {
-		return this.value != null && this.value;
+		return this.value;
+	}
+
+	@Override
+	public @NotNull String getDisplayString() {
+		I18n i18n = I18n.getInstance();
+		if (this.displayStringProvider != null) {
+			return this.displayStringProvider.getDisplayString(Minecraft.getMinecraft(), i18n, this);
+		}
+		if (this.value) {
+			return i18n.translateKey("options.on");
+		} else {
+			return i18n.translateKey("options.off");
+		}
 	}
-	
 }
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionColor.java b/game/client/src/main/java/net/minecraft/client/option/OptionColor.java
index cecc457db..394c34b04 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionColor.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionColor.java
@@ -7,12 +7,12 @@ import org.slf4j.Logger;
 
 public class OptionColor extends Option<Color>{
 	private static final Logger LOGGER = LogUtils.getLogger();
-	public OptionColor(GameSettings gameSettings, String name, Color defaultValue) {
-		super(gameSettings, name, defaultValue);
+	public OptionColor(@NotNull String name, @NotNull Color defaultValue) {
+		super(name, defaultValue);
 	}
 
 	@Override
-	public void parse(@NotNull String string) {
+	public void fromOptionsString(@NotNull String string) {
 		try{
 			this.value.parse(string);
 		}catch (Exception e) {
@@ -21,8 +21,8 @@ public class OptionColor extends Option<Color>{
 	}
 	
 	@Override
-	public @NotNull String getValueString() {
-		return value.toPropertiesString();
+	public @NotNull String toOptionsString() {
+		return this.value.toPropertiesString();
 	}
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionEnum.java b/game/client/src/main/java/net/minecraft/client/option/OptionEnum.java
index 3693e8c04..731c3943e 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionEnum.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionEnum.java
@@ -1,5 +1,8 @@
 package net.minecraft.client.option;
 
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.helper.ITranslatable;
 import net.minecraft.core.util.helper.Toggleable;
 import org.jetbrains.annotations.NotNull;
 
@@ -7,17 +10,17 @@ public class OptionEnum<E extends Enum<?>> extends OptionToggleable<E> implement
 	
 	private boolean isSlider;
 	
-	public OptionEnum(GameSettings gameSettings, String name, Class<E> clazz) {
-		this(gameSettings, name, clazz, clazz.getEnumConstants()[0]);
+	public OptionEnum(@NotNull String name, @NotNull Class<E> clazz) {
+		this(name, clazz, clazz.getEnumConstants()[0]);
 	}
 
-	public OptionEnum(GameSettings gameSettings, String name, Class<E> clazz, E defaultValue) {
-		super(gameSettings, name, defaultValue, clazz.getEnumConstants());
+	public OptionEnum(@NotNull String name, @NotNull Class<E> clazz, @NotNull E defaultValue) {
+		super(name, defaultValue, clazz.getEnumConstants());
 	}
 
 	@Override
-	public void parse(@NotNull String string) {
-		for(E e : values) {
+	public void fromOptionsString(@NotNull String string) {
+		for(E e : this.values) {
 			if(e.toString().equalsIgnoreCase(string)) {
 				this.value = e;
 			}
@@ -31,7 +34,21 @@ public class OptionEnum<E extends Enum<?>> extends OptionToggleable<E> implement
 	
 	@Override
 	public boolean isSlider() {
-		return isSlider;
+		return this.isSlider;
 	}
 
+	@Override
+	public @NotNull String getDisplayString() {
+		I18n i18n = I18n.getInstance();
+		if (this.displayStringProvider != null) {
+			return this.displayStringProvider.getDisplayString(Minecraft.getMinecraft(), i18n, this);
+		}
+		String key;
+		if (this.value instanceof ITranslatable translatable) {
+			key = translatable.getTranslationKey();
+		} else {
+			key = this.value.toString().toLowerCase();
+		}
+		return i18n.translateKey("options." + this.id + "." + key);
+	}
 }
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionFloat.java b/game/client/src/main/java/net/minecraft/client/option/OptionFloat.java
index 20b5cde37..e02d31ebc 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionFloat.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionFloat.java
@@ -1,11 +1,13 @@
 package net.minecraft.client.option;
 
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.lang.I18n;
 import org.jetbrains.annotations.NotNull;
 
 public class OptionFloat extends Option<Float>{
 
-	public OptionFloat(GameSettings gameSettings, String name, float value) {
-		super(gameSettings, name, value);
+	public OptionFloat(@NotNull String name, float value) {
+		super(name, value);
 	}
 
 
@@ -18,7 +20,7 @@ public class OptionFloat extends Option<Float>{
 	}
 
 	@Override
-	public void parse(@NotNull String string) {
+	public void fromOptionsString(@NotNull String string) {
 		if(string.equalsIgnoreCase("true")) {
 			this.value = 1.0f;
 			return;
@@ -31,4 +33,16 @@ public class OptionFloat extends Option<Float>{
 		this.value = Float.parseFloat(string);
 	}
 
+	@Override
+	public @NotNull String getDisplayString() {
+		I18n i18n = I18n.getInstance();
+		if (this.displayStringProvider != null) {
+			return this.displayStringProvider.getDisplayString(Minecraft.getMinecraft(), I18n.getInstance(), this);
+		}
+		if (this.value == 0.0F) {
+			return i18n.translateKey("options.off");
+		} else {
+			return (int) (this.value * 100F) + "%";
+		}
+	}
 }
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionFont.java b/game/client/src/main/java/net/minecraft/client/option/OptionFont.java
index 6e4de8fdb..89fc679e5 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionFont.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionFont.java
@@ -8,12 +8,12 @@ import org.jetbrains.annotations.NotNull;
 
 public class OptionFont extends OptionToggleable<@NotNull Font> implements Toggleable {
 
-    public OptionFont(final GameSettings gameSettings, final String name, final @NotNull Font defaultValue) {
-        super(gameSettings, name, defaultValue, null);
+    public OptionFont(final @NotNull String name, final @NotNull Font defaultValue) {
+        super(name, defaultValue, null);
     }
 
     @Override
-    public void parse(final @NotNull String string) {
+    public void fromOptionsString(final @NotNull String string) {
         this.value = Fonts.fontWithKey(string);
     }
 
@@ -48,7 +48,7 @@ public class OptionFont extends OptionToggleable<@NotNull Font> implements Toggl
     }
 
     @Override
-    public @NotNull String getValueString() {
+    public @NotNull String toOptionsString() {
         return this.value.getKey();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionGuiScale.java b/game/client/src/main/java/net/minecraft/client/option/OptionGuiScale.java
new file mode 100644
index 000000000..b39001470
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionGuiScale.java
@@ -0,0 +1,58 @@
+package net.minecraft.client.option;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.ScaledResolution;
+import org.jetbrains.annotations.NotNull;
+
+public class OptionGuiScale extends OptionToggleable<Integer> {
+    public OptionGuiScale(String name, Integer defaultValue) {
+        super(name, defaultValue, new Integer[1]);
+    }
+
+    @Override
+    public void toggle() {
+        toggle(1);
+    }
+
+    @Override
+    public void toggle(int delta) {
+        int size = size();
+        setValueWithIndex((getValueIndex() + delta) % size);
+    }
+
+    @Override
+    public int getValueIndex() {
+        if (this.value == 0) {
+            return 0;
+        } else {
+            return size() - this.value;
+        }
+    }
+
+    @Override
+    public void setValueWithIndex(int i) {
+        if (i != 0) {
+            this.value = size() - i;
+        } else {
+            this.value = i;
+        }
+    }
+
+    @Override
+    public int size() {
+        Minecraft mc = Minecraft.getMinecraft();
+        int width = mc.resolution.getWidthScreenCoords();
+        int height = mc.resolution.getHeightScreenCoords();
+        return ScaledResolution.getMaxScale(width, height);
+    }
+
+    @Override
+    public boolean isSlider() {
+        return true;
+    }
+
+    @Override
+    public void fromOptionsString(@NotNull String string) {
+        this.value = Integer.parseInt(string);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionImmersiveMode.java b/game/client/src/main/java/net/minecraft/client/option/OptionImmersiveMode.java
index 23034b3a9..77feec4dc 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionImmersiveMode.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionImmersiveMode.java
@@ -2,45 +2,45 @@ package net.minecraft.client.option;
 
 public class OptionImmersiveMode extends OptionInteger {
 
-	public OptionImmersiveMode(GameSettings gameSettings) {
-		super(gameSettings, "immersiveMode", 0);
+	public OptionImmersiveMode() {
+		super("immersiveMode", 0);
 	}
 	
 	public void toggle() {
-		value++;
-		value %= 3;
+        this.value++;
+        this.value %= 3;
 	}
 	
 	public boolean drawHand() {
-		return value < 2;
+		return this.value < 2;
 	}
 	
 	public boolean drawChat() {
-		return value < 2;
+		return this.value < 2;
 	}
 	
 	public boolean drawOutline() {
-		return value < 2;
+		return this.value < 2;
 	}
 	
 	public boolean drawNames() {
-		return value < 1;
+		return this.value < 1;
 	}
 	
 	public boolean drawHotbar() {
-		return value < 1;
+		return this.value < 1;
 	}
 	
 	public boolean drawOverlays() {
-		return value < 1;
+		return this.value < 1;
 	}
 	
 	public boolean drawCrosshair() {
-		return value < 2;
+		return this.value < 2;
 	}
 	
 	public boolean drawVignette() {
-		return value < 2;
+		return this.value < 2;
 	}
 	
 	
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionInteger.java b/game/client/src/main/java/net/minecraft/client/option/OptionInteger.java
index 254c6b368..0756e67d4 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionInteger.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionInteger.java
@@ -4,12 +4,12 @@ import org.jetbrains.annotations.NotNull;
 
 public class OptionInteger extends Option<Integer>{
 
-	public OptionInteger(GameSettings gameSettings, String name, int defaultValue) {
-		super(gameSettings, name, defaultValue);
+	public OptionInteger(@NotNull String name, int defaultValue) {
+		super(name, defaultValue);
 	}
 
 	@Override
-	public void parse(@NotNull String string) {
+	public void fromOptionsString(@NotNull String string) {
 		this.value = Integer.parseInt(string);
 	}
 
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionRange.java b/game/client/src/main/java/net/minecraft/client/option/OptionRange.java
index e4f3a3299..36a7d9096 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionRange.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionRange.java
@@ -5,19 +5,19 @@ import org.jetbrains.annotations.NotNull;
 public class OptionRange extends OptionToggleable<Integer> {
 	public final int highest;
 	public final int lowest;
-    public OptionRange(GameSettings gameSettings, String name, int defaultValue, int values) {
-        super(gameSettings, name, defaultValue, getValueArray(values));
+    public OptionRange(@NotNull String name, int defaultValue, int values) {
+        super(name, defaultValue, getValueArray(values));
         this.highest = this.values[this.values.length - 1];
         this.lowest = this.values[0];
     }
-	public OptionRange(GameSettings gameSettings, String name, int defaultValue, int lowest, int highest) {
-		super(gameSettings, name, defaultValue, getValueArray(lowest, highest));
+	public OptionRange(@NotNull String name, int defaultValue, int lowest, int highest) {
+		super(name, defaultValue, getValueArray(lowest, highest));
 		this.highest = highest;
 		this.lowest = lowest;
 	}
 
 	@Override
-	public void parse(@NotNull String string) {
+	public void fromOptionsString(@NotNull String string) {
 		this.value = Integer.parseInt(string);
 	}
     
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionString.java b/game/client/src/main/java/net/minecraft/client/option/OptionString.java
index e69745bdb..aa4e17125 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionString.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionString.java
@@ -4,12 +4,12 @@ import org.jetbrains.annotations.NotNull;
 
 public class OptionString extends Option<String>{
 
-	public OptionString(GameSettings gameSettings, String name, String defaultValue) {
-		super(gameSettings, name, defaultValue);
+	public OptionString(@NotNull String name, @NotNull String defaultValue) {
+		super(name, defaultValue);
 	}
 
 	@Override
-	public void parse(@NotNull String string) {
+	public void fromOptionsString(@NotNull String string) {
 		this.value = string;
 	}
 
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionToggleable.java b/game/client/src/main/java/net/minecraft/client/option/OptionToggleable.java
index d4dc88641..37242801f 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionToggleable.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionToggleable.java
@@ -2,39 +2,40 @@ package net.minecraft.client.option;
 
 import net.minecraft.client.render.dynamictexture.DynamicTexture;
 import net.minecraft.core.util.helper.Toggleable;
+import org.jetbrains.annotations.NotNull;
 
 public abstract class OptionToggleable<E> extends Option<E> implements Toggleable{
 
 	public E[] values;
 	
-	public OptionToggleable(GameSettings gameSettings, String name, E defaultValue, E[] values) {
-		super(gameSettings, name, defaultValue);
+	public OptionToggleable(@NotNull String name, @NotNull E defaultValue, E[] values) {
+		super(name, defaultValue);
 		
 		this.values = values;
 	}
 	
 	@Override
 	public void toggle() {
-		this.value = values[(getValueIndex() + 1) % values.length];
+		this.value = this.values[(getValueIndex() + 1) % this.values.length];
 	}
 	
 	public void toggle(int delta) {
-		this.value = values[DynamicTexture.pmod(getValueIndex() + delta, values.length)];
+		this.value = this.values[DynamicTexture.pmod(getValueIndex() + delta, this.values.length)];
 	}
 	
 	public int getValueIndex() {
-		for(int i=0; i < values.length; i++) {
-			if(value == values[i]) return i;
+		for(int i = 0; i < this.values.length; i++) {
+			if(this.value == this.values[i]) return i;
 		}
 		return 0;
 	}
 	
 	public void setValueWithIndex(int i) {
-		this.value = values[i];
+		this.value = this.values[i];
 	}
 	
 	public int size() {
-		return values.length;
+		return this.values.length;
 	}
 	
 	public abstract boolean isSlider();
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionTooltip.java b/game/client/src/main/java/net/minecraft/client/option/OptionTooltip.java
index 6905430a7..6cf41251b 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionTooltip.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionTooltip.java
@@ -7,12 +7,12 @@ import org.jetbrains.annotations.NotNull;
 
 public class OptionTooltip extends OptionToggleable<String> implements Toggleable {
 
-    public OptionTooltip(final GameSettings gameSettings, final String name, final String defaultValue) {
-        super(gameSettings, name, defaultValue, null);
+    public OptionTooltip(final @NotNull String name, final @NotNull String defaultValue) {
+        super(name, defaultValue, null);
     }
 
     @Override
-    public void parse(final @NotNull String string) {
+    public void fromOptionsString(final @NotNull String string) {
         this.value = string;
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionVolume.java b/game/client/src/main/java/net/minecraft/client/option/OptionVolume.java
index 159567b38..163a2028b 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionVolume.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionVolume.java
@@ -1,33 +1,35 @@
 package net.minecraft.client.option;
 
 import com.mojang.logging.LogUtils;
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.sound.SoundCategoryHelper;
 import net.minecraft.client.sound.SoundEngine;
 import net.minecraft.core.sound.SoundCategory;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 import paulscode.sound.SoundSystem;
 
 public class OptionVolume extends OptionFloat {
 	private static final Logger LOGGER = LogUtils.getLogger();
-	public final SoundCategory soundCategory;
+	public final @NotNull SoundCategory soundCategory;
 
 	//do *not* add @NotNull to gameSettings here, breaks modding for some abstract reason
-	public OptionVolume(GameSettings gameSettings, String name, float value, SoundCategory soundCategory) {
-		super(gameSettings, name, value);
+	public OptionVolume(@NotNull String name, float value, @NotNull SoundCategory soundCategory) {
+		super(name, value);
 		this.soundCategory = soundCategory;
 	}
 	
 	@Override
 	public void onUpdate() {
 		super.onUpdate();
-		gameSettings.mc.sndManager.updateOptions();
+		Minecraft.getMinecraft().sndManager.updateOptions();
 		SoundSystem soundSystem = SoundEngine.getSoundSystem();
 		try {
 			if (soundSystem != null) {
-				if (soundCategory != SoundCategory.GUI_SOUNDS && !soundSystem.playing("sound_audio_options")) {
-					gameSettings.mc.sndManager.playSoundWithID(soundCategory.changedSound, soundCategory, 1f, 1f, "sound_audio_options");
-				} else if (soundCategory != SoundCategory.GUI_SOUNDS) {
-					soundSystem.setVolume("sound_audio_options", SoundCategoryHelper.getEffectiveVolume(soundCategory, gameSettings));
+				if (this.soundCategory != SoundCategory.GUI_SOUNDS && !soundSystem.playing("sound_audio_options")) {
+					Minecraft.getMinecraft().sndManager.playSoundWithID(this.soundCategory.changedSound, this.soundCategory, 1f, 1f, "sound_audio_options");
+				} else if (this.soundCategory != SoundCategory.GUI_SOUNDS) {
+					soundSystem.setVolume("sound_audio_options", SoundCategoryHelper.getEffectiveVolume(this.soundCategory));
 				}
 			}
 		} catch (Exception e) { // Not sure why but this block of code, specifically the `soundSystem.playing("sound_audio_options")` line seems to be able to through an NPE *sometimes* for *some* users.
diff --git a/game/client/src/main/java/net/minecraft/client/option/enums/CloudQuality.java b/game/client/src/main/java/net/minecraft/client/option/enums/CloudQuality.java
new file mode 100644
index 000000000..4868b14cf
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/option/enums/CloudQuality.java
@@ -0,0 +1,6 @@
+package net.minecraft.client.option.enums;
+
+public enum CloudQuality {
+    FAST,
+    FANCY;
+}
diff --git a/game/client/src/main/java/net/minecraft/client/option/enums/DescriptionPromptEnum.java b/game/client/src/main/java/net/minecraft/client/option/enums/DescriptionPromptEnum.java
index 16b1e0b24..faa2db48e 100644
--- a/game/client/src/main/java/net/minecraft/client/option/enums/DescriptionPromptEnum.java
+++ b/game/client/src/main/java/net/minecraft/client/option/enums/DescriptionPromptEnum.java
@@ -1,14 +1,13 @@
 package net.minecraft.client.option.enums;
 
-import net.minecraft.client.Minecraft;
-import org.jetbrains.annotations.NotNull;
+import net.minecraft.client.option.GameSettings;
 
 public enum DescriptionPromptEnum {
     NEVER_PROMPT,
     PROMPT,
     ALWAYS_SHOW;
 
-    public static boolean showDescription(@NotNull final Minecraft minecraft) {
-        return (minecraft.gameSettings.itemDescriptions.value == DescriptionPromptEnum.ALWAYS_SHOW || minecraft.gameSettings.keyDescription.isPressed());
+    public static boolean showDescription() {
+        return (GameSettings.ITEM_DESCRIPTIONS.value == DescriptionPromptEnum.ALWAYS_SHOW || GameSettings.KEY_DESCRIPTION.isPressed());
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/option/enums/LeavesQuality.java b/game/client/src/main/java/net/minecraft/client/option/enums/LeavesQuality.java
new file mode 100644
index 000000000..a60a3f3fc
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/option/enums/LeavesQuality.java
@@ -0,0 +1,7 @@
+package net.minecraft.client.option.enums;
+
+public enum LeavesQuality {
+    FAST,
+    SMART,
+    FANCY;
+}
diff --git a/game/client/src/main/java/net/minecraft/client/option/enums/ParticlesQuality.java b/game/client/src/main/java/net/minecraft/client/option/enums/ParticlesQuality.java
new file mode 100644
index 000000000..43fa1a6c5
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/option/enums/ParticlesQuality.java
@@ -0,0 +1,7 @@
+package net.minecraft.client.option.enums;
+
+public enum ParticlesQuality {
+    NONE,
+    REDUCED,
+    ALL,
+}
